commit fdda43839d1737da8cb8ca98c1b6e1a89e5eb7d7
Author: freddy77 <freddy77>
Date:   Sat Jul 24 12:41:01 2010 +0000

    avoid overflow skipping wrong characters

diff --git a/ChangeLog b/ChangeLog
index 2d671ea..d6723f4 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Jul 24 14:40:44 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/iconv.c: avoid overflow skipping wrong characters
+
 Sat Jul 24 10:25:53 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc_util.c: remove warning
 
@@ -2748,4 +2751,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3091 2010/07/24 08:26:01 freddy77 Exp $
+$Id: ChangeLog,v 1.3092 2010/07/24 12:41:01 freddy77 Exp $
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 2825f0d..3fb27ee 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.144 2010/06/27 17:46:43 berryc Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.145 2010/07/24 12:41:03 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -1101,6 +1101,8 @@ skip_one_input_sequence(iconv_t cd, const TDS_ENCODING * charset, const char **i
 
 	/* usually fixed size and UTF-8 do not have state, so do not reset it */
 	if (charsize) {
+		if (charsize > *input_size)
+			return 0;
 		*input += charsize;
 		*input_size -= charsize;
 		return charsize;
@@ -1121,6 +1123,8 @@ skip_one_input_sequence(iconv_t cd, const TDS_ENCODING * charset, const char **i
 		do {
 			++charsize;
 		} while ((c <<= 1) & 0x80);
+		if (charsize > *input_size)
+			return 0;
 		*input += charsize;
 		*input_size -= charsize;
 		return charsize;

